
from django.db import models
from django.db.models import Max
from datetime import datetime
from django.utils import formats
#from dbview.models import DbView
#import django_filters
# Create your models here.

class bill_counter(models.Model):
    id = models.BigAutoField(primary_key=True)
    dateandtime=models.CharField(max_length=16)
    quantity=models.IntegerField()
    def __str__(self):
        return self.name

class warehouse_inv(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    address=models.CharField(max_length=128)
    telephone=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id


class categories_shop(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class category_shop(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class shop(models.Model):
    id = models.BigAutoField(primary_key=True)
    category_shop=models.ForeignKey(category_shop, on_delete=models.CASCADE, default="")
    name=models.CharField(max_length=64)
    address=models.CharField(max_length=128)
    telephone=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class account_category(models.Model):

    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class account(models.Model):
    id = models.BigAutoField(primary_key=True)
    account_category=models.ForeignKey(account_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)
    bk_status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class expenses(models.Model):
    id = models.BigAutoField(primary_key=True)
    account=models.ForeignKey(account, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    bk_status=models.CharField(max_length=64, default="")
    details=models.CharField(max_length=64, default="")
    trans_date=models.DateTimeField(max_length=64, default="")

    def __str__(self):
        return self.name

class my_expenses(models.Model):
    id = models.BigAutoField(primary_key=True)
    account=models.ForeignKey(account, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    status=models.CharField(max_length=64, default="")
    details=models.CharField(max_length=64, default="")
    trans_date=models.DateTimeField(max_length=64, default="")

    def __str__(self):
        return self.name


class temp_sales_token(models.Model):
    id = models.BigAutoField(primary_key=True)
    sales_token_no=models.CharField(max_length=16)
    tokendateandtime=models.DateTimeField()
    token_status=models.CharField(max_length=32, default="")
    user_open_token=models.CharField(max_length=32, default="")
    user_close_token=models.CharField(max_length=32, default="")
    customer_name=models.CharField(max_length=128, null=True, default="")
    phone_number=models.CharField(max_length=32, null=True, default="")
    shop=models.ForeignKey(shop, on_delete=models.CASCADE, default="")
    payment_method=models.CharField(max_length=32, null=True, default="")
    card_no=models.CharField(max_length=32, null=True, default="")
    
    def __str__(self):
        return self.name
        ##wulidal huda

class sales_token_counter(models.Model):
    id = models.BigAutoField(primary_key=True)
    tokendate=models.DateTimeField(max_length=64, default="")
    quantity=models.IntegerField()

    def __str__(self):
        return self.name

class count_tokens(models.Model):
    id = models.BigAutoField(primary_key=True)
    tokendate=models.DateTimeField(max_length=64, default="")
    quantity=models.IntegerField()

    def __str__(self):
        return self.name

class item(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)
    category=models.CharField(max_length=64,default="")

    def __str__(self):
        return self.name

class item_size(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_brand(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_desc(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_id= models.ForeignKey(item, on_delete=models.CASCADE)
    item_brand_id= models.ForeignKey(item_brand, on_delete=models.CASCADE)
    item_size_id= models.ForeignKey(item_size, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id


class product_package_formular_parent(models.Model):
    id = models.BigAutoField(primary_key=True)
    package_name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)
    
    def __str__(self):
        return str(self.id)


class product_package_formular(models.Model):
    id = models.BigAutoField(primary_key=True)
    item= models.ForeignKey(item, on_delete=models.CASCADE)
    product_package_formular_parent= models.ForeignKey(product_package_formular_parent, on_delete=models.CASCADE)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=64)
    
    def __str__(self):
        return str(self.id)

class product_package_formular_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    product_package_formular= models.ForeignKey(product_package_formular, on_delete=models.CASCADE)
    #item= models.ForeignKey(item, on_delete=models.CASCADE)
     
    package_name=models.CharField(max_length=64)
    number_of_items_per_package=models.IntegerField()
    qty_of_single_item_per_uoq=models.DecimalField(max_digits=15, decimal_places=4)
    #uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=64)
     
    def __str__(self):
        return str(self.id)

class product_package_formular_details_package_material(models.Model):
    id = models.BigAutoField(primary_key=True)
    product_package_formular_parent= models.ForeignKey(product_package_formular_parent, on_delete=models.CASCADE, null=True)
    product_package_formular=models.ForeignKey(product_package_formular, on_delete=models.CASCADE, null=True)
    item_package_material= models.ForeignKey(item, on_delete=models.CASCADE)
    qty_of_single_item_per_uoq=models.DecimalField(max_digits=15, decimal_places=4)
    status=models.CharField(max_length=64)
    package_material_category=models.CharField(max_length=64)
    no_of_bottles=models.IntegerField()
    
    def __str__(self):
        return str(self.id)


class balance_alert(models.Model):
    id = models.BigAutoField(primary_key=True)
    item= models.ForeignKey(item, on_delete=models.CASCADE, null=True)
    
    balance=models.DecimalField(max_digits=15, decimal_places=4)
    status=models.CharField(max_length=64)
    dot=models.DateTimeField(max_length=64)
    
    def __str__(self):
        return str(self.id)



class temp_sales_token_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    item_desc=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    uoq=models.CharField(max_length=32)

    def __str__(self):
        return self.id
#inv_no_settings

class temp_sales_token_paid_amount(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64)
    payment_method=models.CharField(max_length=32)
    payment_no=models.CharField(max_length=16, null=True)

    def __str__(self):
        return self.id


class temp_sales_token_discount_amount(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64)

    def __str__(self):
        return str(self.id)




class temp_sales_token_details_lb(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    #item=models.ForeignKey(item, on_delete=models.CASCADE)
    product_package_formular_parent=models.ForeignKey(product_package_formular_parent, on_delete=models.CASCADE, default="")
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    uoq=models.CharField(max_length=32, null=True)

    def __str__(self):
        return str(self.id)
#inv_no_settings

class temp_sales_token_paid_amount_lb(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64)
    payment_method=models.CharField(max_length=32)
    payment_no=models.CharField(max_length=16, null=True)

    def __str__(self):
        return str(self.id)


class temp_sales_token_discount_amount_lb(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    amount=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64)

    def __str__(self):
        return str(self.id)



# class temp_sales_token_details_hc_adm(models.Model):
#     id = models.BigAutoField(primary_key=True)
#     temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
#     admission=models.ForeignKey(admission, on_delete=models.CASCADE)
#     unit_price=models.DecimalField(max_digits=9, decimal_places=2)
#     quantity=models.DecimalField(max_digits=9, decimal_places=2)
#     trans_date=models.DateTimeField(max_length=64, null=True)
#     #uoq=models.CharField(max_length=32)

#     def __str__(self):
#         return str(self.id)



class inv_no_settings(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.name

class item_inv_no_settings(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_id=models.ForeignKey(item, on_delete=models.CASCADE)
    inv_no_settings_id=models.ForeignKey(inv_no_settings, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id
#qty_measure
class qty_measure(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.name
#qty_measure_datainv
class qty_measure_data(models.Model):
    id = models.BigAutoField(primary_key=True)
    qty_measure_id=models.ForeignKey(qty_measure, on_delete=models.CASCADE)
    units=models.IntegerField()
    status=models.CharField(max_length=64)
    qty_num=models.DecimalField(max_digits=11, decimal_places=2)

    def __str__(self):
        return self.id

#item_measures
class item_measures(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_id=models.ForeignKey(item, on_delete=models.CASCADE)
    qty_measure_id=models.ForeignKey(qty_measure, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)
    def __str__(self):
        return self.id

class t_purchases(models.Model):
    id = models.BigAutoField(primary_key=True)
    date_and_time=models.DateTimeField(max_length=64)
    status=models.CharField(max_length=64)
    batch_no=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class purchases_store(models.Model):
    id = models.BigAutoField(primary_key=True)
    purchases_id=models.ForeignKey(t_purchases, on_delete=models.CASCADE,null=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    unit_price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    uoq=models.CharField(max_length=64)
    category=models.CharField(max_length=64, null=True)

    def __str__(self):
        return self.id

class purchases_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    purchases_id=models.ForeignKey(t_purchases, on_delete=models.CASCADE)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    unit_price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    uoq=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class company(models.Model):
    id = models.BigAutoField(primary_key=True)
    company_no=models.CharField(max_length=16)
    name=models.CharField(max_length=128)
    email=models.CharField(max_length=128, null=True)
    telephone1=models.CharField(max_length=16)
    telephone2=models.CharField(max_length=16, null=True)
    tin_no=models.CharField(max_length=16, null=True)
    status=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)

class login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    status=models.CharField(max_length=64)
    name=models.CharField(max_length=64)
    details=models.CharField(max_length=254, default="")

    def __str__(self):
        return self.id

class users(models.Model):
    id = models.BigAutoField(primary_key=True)
    company= models.ForeignKey(company, on_delete=models.CASCADE, default="")
    status=models.CharField(max_length=64)
    username=models.CharField(max_length=64)
    useremail=models.EmailField(max_length=128)

    def __str__(self):
        return str(self.id)

class user_password(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)
    password=models.CharField(max_length=256)
    issue_date=models.DateTimeField(max_length=32)
    expire_date=models.DateTimeField(max_length=32)

    def __str__(self):
        return self.id
###user_login_category ###user_login_category
class user_login_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE)
    login_category_id=models.ForeignKey(login_category, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class roles(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    details=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class category_roles(models.Model):
    id = models.BigAutoField(primary_key=True)
    #login_category
    role_id=models.ForeignKey(roles, on_delete=models.CASCADE)
    login_category_id=models.ForeignKey(login_category, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class user_sessions(models.Model):
    id = models.BigAutoField(primary_key=True)
    users=models.ForeignKey(users, on_delete=models.CASCADE)
    session_str=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)



class patient(models.Model):
    id = models.BigAutoField(primary_key=True)
    first_name=models.CharField(max_length=64)
    middle_name=models.CharField(max_length=64)
    last_name=models.CharField(max_length=64)
    telephone=models.CharField(max_length=64)
    nationality=models.CharField(max_length=64)
    gender=models.CharField(max_length=16)
    dob=models.DateTimeField(max_length=64, default="", null=True) ###DOC
    status=models.CharField(max_length=64)
    age=models.CharField(max_length=16,null=True)
    address=models.CharField(max_length=64,null=True)
    patient_code=models.CharField(max_length=16)

    def __str__(self):
        return str(self.id)


class insurance(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    telephone=models.CharField(max_length=32,default="", null=True)
    status=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)

class patient_insurance_card(models.Model):
    id = models.BigAutoField(primary_key=True)
    patient=models.ForeignKey(patient, on_delete=models.CASCADE)
    insurance=models.ForeignKey(insurance, on_delete=models.CASCADE,null=True)
    insurance_card_no=models.CharField(max_length=32)
    status=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)


class shop_manager(models.Model):
    id = models.BigAutoField(primary_key=True)
    shop_id=models.ForeignKey(shop, on_delete=models.CASCADE)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return self.id

class warehouse(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    address=models.CharField(max_length=128)
    telephone=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class warehouse_manager(models.Model):
    id = models.BigAutoField(primary_key=True)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    users_id=models.ForeignKey(users, on_delete=models.CASCADE, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)
         #sss
class supplier(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    email=models.CharField(max_length=128)
    telephone1=models.CharField(max_length=128)
    telephone2=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)


class employee(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    email=models.CharField(max_length=128)
    telephone1=models.CharField(max_length=128)
    telephone2=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)


class employees_wages(models.Model):
    id = models.BigAutoField(primary_key=True)
    amount=models.DecimalField(max_digits=11, decimal_places=2)
    employee=models.ForeignKey(employee, on_delete=models.CASCADE)
    wages_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class employee_wages_expenses(models.Model):
    id = models.BigAutoField(primary_key=True)
    expenses=models.ForeignKey(expenses, on_delete=models.CASCADE)
    employees_wages=models.ForeignKey(employees_wages, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class service_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class medical_service(models.Model):
    id = models.BigAutoField(primary_key=True)
    service_category=models.ForeignKey(service_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class medical_service_fee(models.Model):
    id = models.BigAutoField(primary_key=True)
    medical_service=models.ForeignKey(medical_service, on_delete=models.CASCADE)
    fee_amount=models.DecimalField(max_digits=11, decimal_places=2)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class lab_test_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    service_category=models.ForeignKey(service_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class lab_test(models.Model):
    id = models.BigAutoField(primary_key=True)
    lab_test_category=models.ForeignKey(lab_test_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class lab_test_fee(models.Model):
    id = models.BigAutoField(primary_key=True)
    lab_test=models.ForeignKey(lab_test, on_delete=models.CASCADE)
    fee_amount=models.DecimalField(max_digits=11, decimal_places=2)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id) 

class lab_test_result_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    lab_test=models.ForeignKey(lab_test, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class medicine_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    service_category=models.ForeignKey(service_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class medicine(models.Model):
    id = models.BigAutoField(primary_key=True)
    medicine_category=models.ForeignKey(medicine_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    prod_name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class medicine_product(models.Model):
    id = models.BigAutoField(primary_key=True)
    medicine=models.ForeignKey(medicine, on_delete=models.CASCADE)
    prod_name=models.CharField(max_length=128)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

###MORARILITY
class medicine_item(models.Model):
    id = models.BigAutoField(primary_key=True)
    medicine_product=models.ForeignKey(medicine_product, on_delete=models.CASCADE)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class medicine_cost(models.Model):
    id = models.BigAutoField(primary_key=True)
    medicine_product=models.ForeignKey(medicine_product, on_delete=models.CASCADE)
    cost_amount=models.DecimalField(max_digits=11, decimal_places=2)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class admission(models.Model):
    id = models.BigAutoField(primary_key=True)
    service_category=models.ForeignKey(service_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    prod_name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class admission_cost(models.Model):
    id = models.BigAutoField(primary_key=True)
    admission=models.ForeignKey(admission, on_delete=models.CASCADE)
    fee_amount=models.DecimalField(max_digits=11, decimal_places=2)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)


class consultation(models.Model):
    id = models.BigAutoField(primary_key=True)
    service_category=models.ForeignKey(service_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    prod_name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class consultation_cost(models.Model):
    id = models.BigAutoField(primary_key=True)
    consultation=models.ForeignKey(consultation, on_delete=models.CASCADE)
    fee_amount=models.DecimalField(max_digits=11, decimal_places=2)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)


class diagnosis_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    service_category=models.ForeignKey(service_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=128)
    prod_name=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class diagnosis(models.Model):
    id = models.BigAutoField(primary_key=True)
    diagnosis_category=models.ForeignKey(diagnosis_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    fee_amount=models.DecimalField(max_digits=11, decimal_places=2)
    creation_date = models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    status=models.CharField(max_length=64)
    
    def __str__(self):
        return str(self.id)

class temp_sales_token_details_hc_adm(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    admission=models.ForeignKey(admission, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64, null=True)
    discharge_date=models.DateTimeField(max_length=64, null=True)
    pay_status=models.CharField(max_length=16,default="B")
    #uoq=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)

###  tempsalestokendetailshclab   
#  
class temp_sales_token_details_hc_lab(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    lab_test=models.ForeignKey(lab_test, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64, null=True)
    test_taken_date_time=models.DateTimeField(max_length=64, null=True)
    test_taken_username=models.CharField(max_length=64,default="")
    test_taken_status=models.CharField(max_length=32,default="")
    test_result_date_time=models.DateTimeField(max_length=64, null=True)
    test_result_username=models.CharField(max_length=64,default="")
    test_result=models.CharField(max_length=128,default="")
    pay_status=models.CharField(max_length=16,default="B")
    #uoq=models.CharField(max_length=32)
    
    def __str__(self):
        return str(self.id)

class temp_sales_token_details_hc_lab_result(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token_details_hc_lab=models.ForeignKey(temp_sales_token_details_hc_lab, on_delete=models.CASCADE)
    lab_test_result_category=models.ForeignKey(lab_test_result_category, on_delete=models.CASCADE)
    
    test_result_date_time=models.DateTimeField(max_length=64, null=True)
    test_result_username=models.CharField(max_length=64,default="")
    test_result=models.CharField(max_length=128,default="")
    pay_status=models.CharField(max_length=16,default="B")
    #uoq=models.CharField(max_length=32)
    
    def __str__(self):
        return str(self.id)

class temp_sales_token_details_hc_medical_service(models.Model): ### medser-->
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    medical_service=models.ForeignKey(medical_service, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    details=models.CharField(max_length=128,default="")
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64, null=True)
    medical_service_taken_date_time=models.DateTimeField(max_length=64, null=True)
    medical_service_taken_username=models.CharField(max_length=64,default="")
    medical_service_taken_status=models.CharField(max_length=32,default="")
    medical_service_result_date_time=models.DateTimeField(max_length=64, null=True)
    medical_service_result_username=models.CharField(max_length=64,default="")
    medical_service_result=models.CharField(max_length=128,default="")
    pay_status=models.CharField(max_length=16,default="B")
    #uoq=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)


class temp_sales_token_doctor(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    users=models.ForeignKey(users, on_delete=models.CASCADE)
    patient=models.ForeignKey(patient, on_delete=models.CASCADE,default="")
    status=models.CharField(max_length=16,default="")
    #uoq=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)

class temp_sales_token_details_hc_consul(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    consultation=models.ForeignKey(consultation, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64, null=True)
    pay_status=models.CharField(max_length=32,default="B")
    #uoq=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)



class medical_history_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64,default="")
    short_name=models.CharField(max_length=16)
    status=models.CharField(max_length=32)

    def __str__(self):
        return str(self.id)

class hc_consultation_symptom(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token_details_hc_consul=models.ForeignKey(temp_sales_token_details_hc_consul, on_delete=models.CASCADE)
    medical_history_category=models.ForeignKey(medical_history_category, on_delete=models.CASCADE, default="")
    trans_date=models.DateTimeField(max_length=64, null=True)
    name=models.CharField(max_length=128,default="")


    def __str__(self):
        return str(self.id)


class count_patient(models.Model):
    id = models.BigAutoField(primary_key=True)
    quantity=models.IntegerField()
    status=models.CharField(max_length=32)

class temp_sales_token_details_hc_med(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    medicine_product=models.ForeignKey(medicine_product, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    trans_date=models.DateTimeField(max_length=64, null=True)
    pay_status=models.CharField(max_length=32,default="B")
    uoq=models.CharField(max_length=16,default="")
    frequency=models.CharField(max_length=64,default="")

    def __str__(self):
        return str(self.id)

class customer(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    email=models.CharField(max_length=128)
    telephone1=models.CharField(max_length=128)
    telephone2=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return self.id

class stock_requisition(models.Model):
    id = models.BigAutoField(primary_key=True)
    category=models.CharField(max_length=128, default="")
    stock_requisition_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    status=models.CharField(max_length=64, default="")
    origin=models.CharField(max_length=128, default="")
    destination=models.CharField(max_length=128, default="")

    def __str__(self):
        return self.id

class stock_requisition_supplier_from(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    supplier_id=models.ForeignKey(supplier, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_customer_from(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    customer_id=models.ForeignKey(customer, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_warehouse_from(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_supplier_to(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    supplier_id=models.ForeignKey(supplier, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_customer_to(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    customer_id=models.ForeignKey(customer, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_warehouse_to(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return self.id

class stock_requisition_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_id=models.ForeignKey(stock_requisition, on_delete=models.CASCADE)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    ###lobster

    def __str__(self):
        return self.id

class stock_in_to_shop_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    shop_id=models.ForeignKey(shop, on_delete=models.CASCADE, default="", null=True)
    stock_in_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    temp_sales_token_details_id=models.ForeignKey(temp_sales_token_details, on_delete=models.CASCADE, default="", null=True)
    ###goggins

    def __str__(self):
        return str(self.id)



# class product_package_formular(models.Model):
#     id = models.BigAutoField(primary_key=True)
#     item= models.ForeignKey(item, on_delete=models.CASCADE)
#     uoq=models.CharField(max_length=32)
#     status=models.CharField(max_length=64)

#     def __str__(self):
#         return str(self.id)

# class product_package_formular_details(models.Model):
#     id = models.BigAutoField(primary_key=True)
#     product_package_formular= models.ForeignKey(product_package_formular, on_delete=models.CASCADE)
#     #item= models.ForeignKey(item, on_delete=models.CASCADE)
#     package_name=models.CharField(max_length=64)
#     number_of_items_per_package=models.IntegerField()
#     qty_of_single_item_per_uoq=models.DecimalField(max_digits=15, decimal_places=4)
#     #uoq=models.CharField(max_length=32)
#     status=models.CharField(max_length=64)

#     def __str__(self):
#         return str(self.id)



class item_production(models.Model):
    id = models.BigAutoField(primary_key=True)
    production_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    username=models.CharField(max_length=64)
    status=models.CharField(max_length=32)
    category=models.CharField(max_length=32)
    product_package_formular_parent=models.ForeignKey(product_package_formular_parent, on_delete=models.CASCADE)

    def __str__(self):
        return str(self.id)

class item_production_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_production=models.ForeignKey(item_production, on_delete=models.CASCADE)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    temp_sales_token_details_lb=models.ForeignKey(temp_sales_token_details_lb, on_delete=models.CASCADE,default="",null=True)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    product_package_formular_parent=models.ForeignKey(product_package_formular_parent, on_delete=models.CASCADE,default="", null=True)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=32,default="")
    prod_status=models.CharField(max_length=32,default="")

    def __str__(self):
        return str(self.id)

class item_production_details_semi_to_final(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_production_details=models.ForeignKey(item_production_details, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=32,default="")
    prod_status=models.CharField(max_length=32,default="")
    def __str__(self):
        return str(self.id)

class item_production_details_previous_semi_to_final(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_production_details=models.ForeignKey(item_production_details, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=32,default="")
    prod_status=models.CharField(max_length=32,default="")
    def __str__(self):
        return str(self.id)

class stock_in_to_production_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    shop_id=models.ForeignKey(shop, on_delete=models.CASCADE, default="", null=True)
    stock_in_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    quantity=models.DecimalField(max_digits=11, decimal_places=4)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    item_production_details_id=models.ForeignKey(item_production_details, on_delete=models.CASCADE, default="", null=True)
    ###goggins

    def __str__(self):
        return str(self.id)


class stock_in_to_warehouse_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    warehouse_inv_id=models.ForeignKey(warehouse_inv, on_delete=models.CASCADE, default="", null=True)
    stock_in_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    stock_in_to_shop_details_id=models.ForeignKey(stock_in_to_shop_details, on_delete=models.CASCADE, default="", null=True)
    ###goggins

    def __str__(self):
        return self.id


class stock_balance_warehouse(models.Model):
    id = models.BigAutoField(primary_key=True)
    stock_requisition_details_id=models.ForeignKey(stock_requisition_details, on_delete=models.CASCADE)
    warehouse_id=models.ForeignKey(warehouse, on_delete=models.CASCADE)
    item_desc_id=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=64)
    status=models.CharField(max_length=64, default="")
    trans_status=models.CharField(max_length=32, default="")

    def __str__(self):
        return self.id

class batch_count(models.Model):
    id = models.BigAutoField(primary_key=True)
    counter=models.IntegerField()
    batch_year=models.CharField(max_length=32)
    status=models.CharField(max_length=64)
    ##yuu
    def __str__(self):
        return str(self.id)


class item_sales_price(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    ##wion
    def __str__(self):
        return str(self.id)


class item_sales_price_lb(models.Model):
    id = models.BigAutoField(primary_key=True)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    ##wion
    def __str__(self):
        return str(self.id)


class purchase_batch(models.Model):
    id = models.BigAutoField(primary_key=True)
    batch_number=models.CharField(max_length=64, default="")
    supplier_id=models.ForeignKey(supplier, on_delete=models.CASCADE)
    batch_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return self.id
         #sss
class mobile_money_sps(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class mobile_money_no(models.Model):
    id = models.BigAutoField(primary_key=True)
    mobile_money_sps=models.ForeignKey(mobile_money_sps, on_delete=models.CASCADE)
    name=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)

class pos_inv_passcode(models.Model):
    id = models.BigAutoField(primary_key=True)
    username=models.CharField(max_length=64, default="")
    passcode=models.CharField(max_length=16, default="")
    status=models.CharField(max_length=64, default="")
    category=models.CharField(max_length=64, default="")
    def __str__(self):
        return str(self.id)


class product_formular(models.Model):
    id = models.BigAutoField(primary_key=True)
    item= models.ForeignKey(item, on_delete=models.CASCADE)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class product_formular_details(models.Model):
    id = models.BigAutoField(primary_key=True)
    product_formular= models.ForeignKey(product_formular, on_delete=models.CASCADE)
    item= models.ForeignKey(item, on_delete=models.CASCADE)
    qty=models.DecimalField(max_digits=15, decimal_places=4)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class product_formular_raw_materials(models.Model):
    id = models.BigAutoField(primary_key=True)
    product_formular= models.ForeignKey(product_formular, on_delete=models.CASCADE)
    item= models.ForeignKey(item, on_delete=models.CASCADE)
    qty=models.DecimalField(max_digits=11, decimal_places=2)
    uoq=models.CharField(max_length=32)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)


# class product_package_formular(models.Model):
#     id = models.BigAutoField(primary_key=True)
#     item= models.ForeignKey(item, on_delete=models.CASCADE)
#     uoq=models.CharField(max_length=32)
#     status=models.CharField(max_length=64)

#     def __str__(self):
#         return str(self.id)




class TestView(models.Model):
    name = models.CharField(max_length=64)
    id = models.BigAutoField(primary_key=True)

    class Meta:
        managed = False
        db_table = "test_view"

class view_v_item_qty_33_1_c(models.Model):
    item_measures_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    qty_measure_id = models.IntegerField()
    qty_measure_name = models.CharField(max_length=64)
    single_unit=models.DecimalField(max_digits=11, decimal_places=2)
    half_unit=models.DecimalField(max_digits=11, decimal_places=2)
    quarter_unit=models.DecimalField(max_digits=11, decimal_places=2)
    category = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_qty_33_1_c"

class view_v_purchases_full_1(models.Model):
    purchases_id = models.BigAutoField(primary_key=True)
    purchases_details_id = models.IntegerField()
    purchases_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    item_desc_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    status = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    unit_price=models.DecimalField(max_digits=11, decimal_places=2)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    total_price=models.DecimalField(max_digits=15, decimal_places=2)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_purchases_full_1"


class view_v_item_desc_1(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    category = models.CharField(max_length=64)
    class Meta:
        managed = False
        db_table = "v_item_desc_1"

class view_v_item_desc_with_uoq_1(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    uoq = models.CharField(max_length=64)
    single_unit = models.IntegerField()
    category = models.CharField(max_length=64)

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_with_uoq_1"


class view_v_item_desc_with_uoq_1_and_price(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    uoq = models.CharField(max_length=64)
    single_unit = models.IntegerField()
    sales_price = models.DecimalField(max_digits=9, decimal_places=2)
    category = models.CharField(max_length=64)
    #amount = models.DecimalField(max_digits=9, decimal_places=2)

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_with_uoq_1_and_price"



class view_v_user_login_details_1_a(models.Model):
    users_id = models.BigAutoField(primary_key=True)
    username = models.CharField(max_length=64)
    password = models.CharField(max_length=564)
    category_name = models.CharField(max_length=64)
    useremail=models.EmailField(max_length=64)
    user_login_category_id = models.IntegerField()
    login_category_id = models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_user_login_details_1_a"
#v_user_login_details_1_a


class view_v_all_expenses_1(models.Model):
    #as expenses_id, b. id as account_id, b.name account_name, amount, trans_date,details,status

    expenses_id = models.BigAutoField(primary_key=True)
    account_id=models.IntegerField()
    account_name = models.CharField(max_length=64)
    amount = models.DecimalField(max_digits=9, decimal_places=2)
    trans_date = models.DateTimeField(max_length=64)
    details = models.CharField(max_length=128)
    status = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_expenses_1"



class view_v_all_expenses_full_1(models.Model):
    #as expenses_id, b. id as account_id, b.name account_name, amount, trans_date,details,status

    expenses_id = models.BigAutoField(primary_key=True)
    account_id=models.IntegerField()
    account_name = models.CharField(max_length=64)
    category_name = models.CharField(max_length=64)
    amount = models.DecimalField(max_digits=9, decimal_places=2)
    trans_date = models.DateTimeField(max_length=64)
    details = models.CharField(max_length=128)
    status = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_expenses_full_1"

class view_v_all_accounts_full_1(models.Model):

    account_id = models.BigAutoField(primary_key=True)
    account_name = models.CharField(max_length=64)
    category_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_accounts_full_1"


class view_v_all_sales_tokens_1(models.Model):
    token_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_sales_tokens_1"



class view_v_all_sales_tokens_1_a(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_sales_tokens_1_a"



class view_v_all_sales_tokens_lb_1_a(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    product_package_formular_parent_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    package_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    #single_unit=models.IntegerField()
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_sales_tokens_lb_1_a"



class view_v_item_sales_price_1(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_1"



class view_v_item_sales_price_1_a(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_1_a"


class view_v_item_sales_price_lb_1_a(models.Model):
    item_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    category = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_lb_1_a"

class viewv_purchases_store_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=128)
    category = models.CharField(max_length=32)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_purchases_store_balance_1_b"

class view_v_all_stock_in_to_shops_1_a(models.Model):
    sits_id = models.BigAutoField(primary_key=True)
    quantity = models.DecimalField(max_digits=11, decimal_places=2)
    shop_id = models.IntegerField()
    item_desc_id=models.IntegerField()
    single_unit=models.IntegerField()
    desc_name = models.CharField(max_length=256)
    shop_name = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=32)
    stock_in_date = models.DateTimeField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_stock_in_to_shops_1_a"

# a.id as sits_id,b.desc_name as desc_name, quantity,uoq,

class view_v_all_stock_in_to_warehouses_1_a(models.Model):
    sits_id = models.BigAutoField(primary_key=True)
    quantity = models.DecimalField(max_digits=11, decimal_places=2)
    warehouse_id = models.IntegerField()
    item_desc_id=models.IntegerField()
    single_unit=models.IntegerField()
    desc_name = models.CharField(max_length=256)
    warehouse_name = models.CharField(max_length=64)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=32)
    stock_in_date = models.DateTimeField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_stock_in_to_warehouses_1_a"

# a.status,a.item_desc_id_id as item_desc_id,a.shop_id_id as shop_id,c.name as shop_name

class viewv_stock_in_to_shop_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=64)
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_stock_in_to_shop_details_balance_1_b"


class view_v_stock_in_to_shop_details_balance_1_c(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    ext_category_id=models.IntegerField()
    category_name = models.CharField(max_length=64)
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=64)
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    sales_price=models.DecimalField(max_digits=11, decimal_places=2)
    #id = models.BigAutoField(primary_key=True) HIVYO
    class Meta:
        managed = False
        db_table = "v_stock_in_to_shop_details_balance_1_c"


class view_v_temp_sales_token_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    sales_token_no=models.CharField(max_length=16)
    tokendateandtime=models.DateTimeField()
    token_status=models.CharField(max_length=32)
    user_open_token=models.CharField(max_length=32)
    user_close_token=models.CharField(max_length=32)
    shop_id=models.IntegerField()
    shop_name=models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_1_a"


class view_v_temp_sales_patient_token_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    sales_token_no=models.CharField(max_length=16)
    tokendateandtime=models.DateTimeField()
    token_status=models.CharField(max_length=32)
    user_open_token=models.CharField(max_length=32)
    user_close_token=models.CharField(max_length=32)
    shop_id=models.IntegerField()
    shop_name=models.CharField(max_length=64)
    patient_id=models.IntegerField()
    patient_name=models.CharField(max_length=64)

    doctors_id=models.IntegerField()
    doctors_name=models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_temp_sales_patient_token_1_a"
        ##


class view_v_images_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    name=models.CharField(max_length=256)
    img=models.CharField(max_length=128)

    class Meta:
        managed = False
        db_table = "v_images_1_a"
        ##wulidal huda

class view_v_temp_sales_token_details_1_a(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    item_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_1_a"



class view_v_temp_sales_token_details_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    ###tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    ##single_unit=models.IntegerField()
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    item_name = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_1_b"



class view_v_item_sales_price_1_c(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    uoq = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    #item_desc_id=models.IntegerField()
    price = models.DecimalField(max_digits=9, decimal_places=2)
    status = models.CharField(max_length=64)

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_sales_price_1_c"

###v_tokens_with_driver_details_1_a
class view_v_stock_in_to_warehouse_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=128)
    warehouse_id=models.IntegerField()
    warehouse_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_stock_in_to_warehouse_details_balance_1_b"



###v_tokens_with_driver_details_1_a
class view_v_stock_in_to_warehouse_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=128)
    warehouse_id=models.IntegerField()
    warehouse_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_stock_in_to_warehouse_details_balance_1_b"

###v_tokens_with_driver_details_1_a
class view_v_stock_in_to_shop_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=128)
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_stock_in_to_shop_details_balance_1_b"


class view_v_stock_in_to_production_details_1_a_2(models.Model):
    stock_in_to_production_details_id = models.BigAutoField(primary_key=True)
    item_desc_id=models.IntegerField()
    item_id=models.IntegerField()
    #single_unit=models.IntegerField()
    #qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq_in = models.CharField(max_length=64)
    qty_in = models.DecimalField(max_digits=11, decimal_places=2)
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=128)
    stock_in_date=models.DateTimeField(max_length=64, default="")
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "stock_in_to_production_details_1_a"

##########_details_balance_1_b"

##########
##########


class view_v_all_items_sold_in_units_v_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    temp_sales_token_id = models.IntegerField()
    uoq = models.CharField(max_length=64)
    quantity = models.DecimalField(max_digits=9, decimal_places=2)
    unit_price = models.DecimalField(max_digits=11, decimal_places=2)
    sales_token_no = models.CharField(max_length=64)
    #desc_name = models.CharField(max_length=256)
    shop_name = models.CharField(max_length=256)
    qty_units = models.DecimalField(max_digits=9, decimal_places=2)
    tokendateandtime = models.DateTimeField(max_length=64, default="")
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_all_items_sold_in_units_v_1_a"


###v_tokens_with_driver_details_1_a
class view_v_purchases_unit_price_unit_v_1_b(models.Model):
    item_id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    single_unit=models.IntegerField()
    unit_price_unit = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    uoq_p = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_purchases_unit_price_unit_v_1_b"


class view_v_purchases_store_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    ###item_desc_id = models.IntegerField()
    single_unit=models.IntegerField()
    qty_balance_units= models.DecimalField(max_digits=11, decimal_places=2)
    #unit_price = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    #uoq_p = models.CharField(max_length=64)
    #id = models.BigAutoField(primary_key=True)
    qty_statement = models.CharField(max_length=128)
    category = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_purchases_store_balance_1_b"

##########


class view_v_all_discounts_1_a(models.Model):
    id = models.BigAutoField(primary_key=True)
    trans_date = models.DateTimeField(max_length=64, default="")
    amount = models.DecimalField(max_digits=11, decimal_places=2)
    shop_name = models.CharField(max_length=256)
    temp_sales_token_id=models.IntegerField()

    class Meta:
        managed = False
        db_table = "v_all_discounts_1_a"

##########


############FOODS START
class food_menu_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

#account_category=models.ForeignKey(account_category, on_delete=models.CASCADE)
class food_menu(models.Model):
    id = models.BigAutoField(primary_key=True)
    food_menu_category=models.ForeignKey(food_menu_category, on_delete=models.CASCADE)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class food_menu_price(models.Model):
    id = models.BigAutoField(primary_key=True)
    food_menu=models.ForeignKey(food_menu, on_delete=models.CASCADE)
    price=models.DecimalField(max_digits=9, decimal_places=2)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)


class food_ingredients(models.Model):
    id = models.BigAutoField(primary_key=True)
    food_menu= models.ForeignKey(food_menu, on_delete=models.CASCADE)
    item= models.ForeignKey(item, on_delete=models.CASCADE)
    qty_measure= models.ForeignKey(qty_measure, on_delete=models.CASCADE)
    unit_qty=models.DecimalField(max_digits=15, decimal_places=11)
    cost= models.DecimalField(max_digits=11, decimal_places=2)
    status=models.CharField(max_length=64)
    
    def __str__(self):
        return str(self.id)


class waiters(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    telephone1=models.CharField(max_length=128)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class tables(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=128)
    no_of_chairs=models.IntegerField()
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)




class temp_sales_token_details_ext_rms(models.Model):
    id = models.BigAutoField(primary_key=True)
    temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    food_menu=models.ForeignKey(food_menu, on_delete=models.CASCADE)
    unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.DecimalField(max_digits=9, decimal_places=2)
    status=models.CharField(max_length=32)
    
    def __str__(self):
        return self.id
    

class tempdocket(models.Model):
    id = models.BigAutoField(primary_key=True)
    docket_no=models.IntegerField()
    food_name=models.CharField(max_length=64)
    bill_no=models.CharField(max_length=32)
    docket_time=models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    # temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    # food_menu=models.ForeignKey(food_menu, on_delete=models.CASCADE)
    # unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    docket_by=models.CharField(max_length=64)
    docketstatus=models.CharField(max_length=64)
    
    def __str__(self):
        return str(self.id)


class tempdocket_log(models.Model):
    id = models.BigAutoField(primary_key=True)
    docket_no=models.IntegerField()
    food_name=models.CharField(max_length=64)
    bill_no=models.CharField(max_length=32)
    docket_time=models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    # temp_sales_token=models.ForeignKey(temp_sales_token, on_delete=models.CASCADE)
    # food_menu=models.ForeignKey(food_menu, on_delete=models.CASCADE)
    # unit_price=models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    docket_by=models.CharField(max_length=64)
    docketstatus=models.CharField(max_length=64)
    username=models.CharField(max_length=64)
    
    def __str__(self):
        return str(self.id)
  
#inv_no_settings tempdocket_log
##########


class view_v_food_price_1_a(models.Model):
    price_id = models.BigAutoField(primary_key=True)
    category_id = models.IntegerField()
    menu_id = models.IntegerField()
    price = models.DecimalField(max_digits=11, decimal_places=2)
    category_name = models.CharField(max_length=256)
    menu_name = models.CharField(max_length=256)

    class Meta:
        managed = False
        db_table = "v_food_price_1_a"

##########


############ FOODS END


##########3 EXT START

class ext_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    name=models.CharField(max_length=64)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class item_ext_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    ext_category=models.ForeignKey(ext_category, on_delete=models.CASCADE)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

class item_desc_ext_category(models.Model):
    id = models.BigAutoField(primary_key=True)
    ext_category=models.ForeignKey(ext_category, on_delete=models.CASCADE)
    item_desc=models.ForeignKey(item_desc, on_delete=models.CASCADE)
    status=models.CharField(max_length=64)

    def __str__(self):
        return str(self.id)

##########3 EXT END

################# IMG START
class order_from_supplier(models.Model):
    id = models.BigAutoField(primary_key=True)
    supplier=models.ForeignKey(supplier, on_delete=models.CASCADE)
    order_date= models.DateTimeField("SHORT_DATETIME_FORMAT", null=True)
    item=models.ForeignKey(item, on_delete=models.CASCADE)
    item_desc_ext_category=models.ForeignKey(item_desc_ext_category, on_delete=models.CASCADE)###item_ext_category
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    delivery_expecting_date=models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    received_date=models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    uoq=models.CharField(max_length=64, default="")
    status=models.CharField(max_length=64, default="")

    def __str__(self):
        return str(self.id)

class Image(models.Model):
    id = models.BigAutoField(primary_key=True)
    name= models.CharField(max_length=500)

    img = models.ImageField(upload_to='images/', default=None)
    item_desc= models.ForeignKey(item_desc, on_delete=models.CASCADE, default="")
    ###STEVE NICOL

    def __str__(self):
        return self.name ###+ ": " + str(self.img)



class view_v_item_desc_with_ext_category_01(models.Model):
    idec_id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    item_id=models.IntegerField()
    category_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_item_desc_with_ext_category_01"


################# IMG END
class view_v_order_from_suppliers_1_a(models.Model):
    order_id = models.BigAutoField(primary_key=True)
    idec_id =  models.IntegerField()
    item_desc_id = models.IntegerField()

    category_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    order_date = models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)
    quantity=models.DecimalField(max_digits=11, decimal_places=2)
    price=models.DecimalField(max_digits=11, decimal_places=2)
    uoq = models.CharField(max_length=64)
    status = models.CharField(max_length=64)
    received_date = models.DateTimeField("SHORT_DATETIME_FORMAT",null=True)

    class Meta:
        managed = False
        db_table = "v_order_from_suppliers_1_a"

###

class view_v_shops_1_a(models.Model):
    shop_id = models.BigAutoField(primary_key=True)
    category_shop_id =  models.IntegerField()
    shop_name = models.CharField(max_length=64)

    category_name = models.CharField(max_length=64)
    address = models.CharField(max_length=128)
    telephone = models.CharField(max_length=16)
    status = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_shops_1_a"


class view_v_product_formular_details_1_a(models.Model):
    product_formular_details_id = models.BigAutoField(primary_key=True)
    product_formular_id=models.IntegerField()

    final_product_item_id=models.IntegerField()
    final_product_item_name = models.CharField(max_length=64)
    final_product_uoq = models.CharField(max_length=32)

    raw_material_item_id=models.IntegerField()
    raw_material_item_name = models.CharField(max_length=64)
    raw_material_uoq = models.CharField(max_length=32)
    raw_material_qty=models.DecimalField(max_digits=11, decimal_places=4)

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_product_formular_details_1_a"



class view_v_package_formular_with_final_product_1_a(models.Model):
    ppf_id = models.BigAutoField(primary_key=True)
    ppfp_id=models.IntegerField()

    item_id=models.IntegerField()
    package_name = models.CharField(max_length=64)
    uoq = models.CharField(max_length=32)
    
    qty_of_single_item_per_uoq=models.IntegerField() ### qty_of_single_item_per_uoq, no_of_bottles
    no_of_bottles=models.IntegerField()
    #raw_material_uoq = models.CharField(max_length=32)
    #raw_material_qty=models.DecimalField(max_digits=11, decimal_places=4)

    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_package_formular_with_final_product_1_a"


class view_v_stock_in_to_production_details_balance_1_b(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    item_id = models.IntegerField()
    single_unit=models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=11, decimal_places=2)
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    qty_statement = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_stock_in_to_production_details_balance_1_b"


class view_v_production_data_details_1_a(models.Model):
    item_production_details_id = models.BigAutoField(primary_key=True)
    item_production_id = models.IntegerField()
    production_date = models.DateTimeField(max_length=64, default="")
    item_id = models.IntegerField()
    product_package_formular_parent_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    quantity = models.DecimalField(max_digits=15, decimal_places=4)
    uoq = models.CharField(max_length=32)
    status = models.CharField(max_length=32)
    prod_status = models.CharField(max_length=32)

    class Meta:
        managed = False
        db_table = "v_production_data_details_1_a"


class view_v_production_data_details_1_b(models.Model):
    item_production_details_id = models.BigAutoField(primary_key=True)
    item_production_id = models.IntegerField()
    production_date = models.DateTimeField(max_length=64, default="")
    item_id = models.IntegerField()
    product_package_formular_parent_id=models.IntegerField()
    item_name = models.CharField(max_length=64)
    quantity = models.DecimalField(max_digits=15, decimal_places=4)
    uoq = models.CharField(max_length=32)
    status = models.CharField(max_length=32)
    prod_status = models.CharField(max_length=32)
    package_material_name = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_production_data_details_1_b"

###v_stock_in_to_production_details_1_a

class view_v_stock_in_to_production_details_1_a(models.Model):
    stock_in_to_production_details_id = models.BigAutoField(primary_key=True)
    item_desc_id = models.IntegerField()
    stock_in_date = models.DateTimeField(max_length=64, default="")
    item_id = models.IntegerField()
    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=128)
    qty_in = models.DecimalField(max_digits=15, decimal_places=4)
    uoq_in = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_stock_in_to_production_details_1_a"


class view_v_stock_in_to_production_data_details_balance_1_b(models.Model):
    item_id = models.BigAutoField(primary_key=True)
    item_name = models.CharField(max_length=64)
    uoq = models.CharField(max_length=32)
    single_unit = models.IntegerField()
    qty_balance_units = models.DecimalField(max_digits=15, decimal_places=4)
    qty_statement = models.CharField(max_length=64)
    
    class Meta:
        managed = False
        db_table = "v_stock_in_to_production_data_details_balance_1_b"

###   v_temp_sales_token_details_lb_1_b

class view_v_temp_sales_token_details_lb_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    sales_token_no = models.CharField(max_length=32)
    product_package_formular_parent_id = models.IntegerField()
    package_name = models.CharField(max_length=64)
    #uoq = models.CharField(max_length=32)
    unit_price = models.DecimalField(max_digits=15, decimal_places=4)

    quantity = models.DecimalField(max_digits=15, decimal_places=4)
    token_status = models.CharField(max_length=64)
    
    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_lb_1_b"


class view_v_balance_of_purchases_and_production_stores_1_a(models.Model):
    item_desc_id = models.BigAutoField(primary_key=True)
    single_unit=models.IntegerField()

    item_name = models.CharField(max_length=64)
    desc_name = models.CharField(max_length=256)
    uoq = models.CharField(max_length=64)
    category = models.CharField(max_length=32)

    qty_balance_units_purchase_store = models.DecimalField(max_digits=11, decimal_places=2)
    qty_statement_purchase_store = models.CharField(max_length=128)

    qty_balance_units_production_store = models.DecimalField(max_digits=11, decimal_places=2)
    qty_statement_production_store = models.CharField(max_length=128)
    #id = models.BigAutoField(primary_key=True)
    class Meta:
        managed = False
        db_table = "v_balance_of_purchases_and_production_stores_1_a"




class view_v_temp_sales_token_details_lb_1_a(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)
    desc_name = models.CharField(max_length=128)
    token_status = models.CharField(max_length=64)
    single_unit=models.IntegerField()

    item_name = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_lb_1_a"



class view_v_temp_sales_token_details_lb_1_c(models.Model):
    token_details_id = models.BigAutoField(primary_key=True)
    item_id=models.IntegerField()
    temp_sales_token_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity=models.IntegerField()
    uoq = models.CharField(max_length=64)
    tokendateandtime = models.DateTimeField(max_length=64)

    token_status = models.CharField(max_length=64)
    single_unit=models.IntegerField()
    shop_id=models.IntegerField()
    shop_name = models.CharField(max_length=64)
    item_name = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_lb_1_c"


class view_v_item_production_raw_to_final_items_1_a(models.Model):
    stock_in_to_production_details_id = models.BigAutoField(primary_key=True)
    raw_material_item_id=models.IntegerField()
    item_desc_id=models.IntegerField()
    item_production_details_id=models.IntegerField()
  
    quantity=models.DecimalField(max_digits=15, decimal_places=7)
    uoq = models.CharField(max_length=64)
    stock_in_date = models.DateTimeField(max_length=64)
    
    status = models.CharField(max_length=64)
    #single_unit=models.IntegerField()
    #shop_id_id=models.IntegerField()
    #shop_name = models.CharField(max_length=64)
    final_product_name = models.CharField(max_length=64)
    raw_material_name = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_item_production_raw_to_final_items_1_a"



class view_v_item_production_raw_to_final_items_1_b(models.Model):
    stock_in_to_production_details_id = models.BigAutoField(primary_key=True)
    raw_material_item_id=models.IntegerField()
    item_desc_id=models.IntegerField()
    item_production_details_id=models.IntegerField()
  
    quantity=models.DecimalField(max_digits=15, decimal_places=7)
    uoq = models.CharField(max_length=64)
    stock_in_date = models.DateTimeField(max_length=64)
    
    status = models.CharField(max_length=64)
    
    final_product_name = models.CharField(max_length=64)
    raw_material_name = models.CharField(max_length=64)
    ###    c.quantity as qty_final_product,c.prod_status dream
    ##amount = models.DecimalField(max_digits=9, decimal_places=2)
    qty_final_product = models.DecimalField(max_digits=15, decimal_places=7)
    prod_status= models.CharField(max_length=32)
    
    class Meta:
        managed = False
        db_table = "v_item_production_raw_to_final_items_1_b"


class view_v_employees_wages_1_a(models.Model):
    employee_wages_id = models.BigAutoField(primary_key=True)
    employee_id=models.IntegerField()
    employee_name = models.CharField(max_length=64)
    telephone1 = models.CharField(max_length=16)
    telephone2 = models.CharField(max_length=16)
    email = models.CharField(max_length=64)

    wages_date = models.CharField(max_length=64)
    amount = models.DecimalField(max_digits=9, decimal_places=2)



    class Meta:
        managed = False
        db_table = "v_employees_wages_1_a"



class view_v_lab_test_category_1_a(models.Model):
    lab_test_category_id = models.BigAutoField(primary_key=True)
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    lab_category_name = models.CharField(max_length=16)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_lab_test_category_1_a"


class view_v_lab_test_1_a(models.Model):
    lab_test_id = models.BigAutoField(primary_key=True)
    lab_test_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    lab_category_name = models.CharField(max_length=64)
    lab_test_name = models.CharField(max_length=128)
    #fee_id=models.IntegerField()
    #fee_amount = models.DecimalField(max_digits=9, decimal_places=2)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_lab_test_1_a"


class view_v_lab_test_with_fee_1_a(models.Model):
    lab_test_id = models.BigAutoField(primary_key=True)
    lab_test_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    lab_category_name = models.CharField(max_length=64)
    lab_test_name = models.CharField(max_length=128)
    fee_id=models.IntegerField()
    fee_amount = models.DecimalField(max_digits=9, decimal_places=2)
    fee_status = models.CharField(max_length=16)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_lab_test_with_fee_1_a"




class view_v_medicine_category_1_a(models.Model):
    medicine_category_id = models.BigAutoField(primary_key=True)
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    medicine_category_name = models.CharField(max_length=16)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_medicine_category_1_a"


class view_v_medicine_1_a(models.Model):
    medicine_id = models.BigAutoField(primary_key=True)
    medicine_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    medicine_category_name = models.CharField(max_length=64)
    medicine_name = models.CharField(max_length=128)
    #fee_id=models.IntegerField()
    #fee_amount = models.DecimalField(max_digits=9, decimal_places=2)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_medicine_1_a"


class view_v_medicine_with_fee_1_a(models.Model):
    medicine_product_id = models.BigAutoField(primary_key=True)
    medicine_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    medicine_category_name = models.CharField(max_length=64)
    medicine_id = models.IntegerField()
    medicine_name = models.CharField(max_length=128)
    medicine_product_name = models.CharField(max_length=128)
    cost_id=models.IntegerField()
    cost_amount = models.DecimalField(max_digits=9, decimal_places=2)

    class Meta:
        managed = False
        db_table = "v_medicine_with_fee_1_a"

###    v_admission_cost_1_a
#
class view_v_admission_cost_1_a(models.Model):
    admission_id = models.BigAutoField(primary_key=True)
    #admission_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category_name = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    admission_name = models.CharField(max_length=128)
    admission_cost_id=models.IntegerField()
    fee_amount = models.DecimalField(max_digits=9, decimal_places=2)
    fee_status = models.CharField(max_length=16)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_admission_cost_1_a"


class view_v_temp_sales_token_details_hc_adm_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    admission_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    admission_name = models.CharField(max_length=128)
    #admission_cost_id=models.IntegerField()
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity = models.DecimalField(max_digits=7, decimal_places=2)
    token_status = models.CharField(max_length=32)
    trans_date=models.DateTimeField(max_length=64, null=True)
    discharge_date=models.DateTimeField(max_length=64, null=True)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_hc_adm_1_b"


class view_v_temp_sales_token_details_hc_lab_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    lab_test_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    lab_test_name = models.CharField(max_length=128)
    #admission_cost_id=models.IntegerField()
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity = models.DecimalField(max_digits=7, decimal_places=2)
    token_status = models.CharField(max_length=32)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name
    test_taken_date_time = models.DateTimeField(max_length=32,default="") ###wages_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    test_taken_status = models.CharField(max_length=64)
    test_result = models.CharField(max_length=64)
    test_result_date_time = models.DateTimeField(max_length=32,default="")
    test_taken_username = models.CharField(max_length=64)
    test_result_username = models.CharField(max_length=64)
    pay_status = models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_hc_lab_1_b"

class view_v_consultation_cost_1_a(models.Model):
    consultation_id = models.BigAutoField(primary_key=True)
    #admission_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category_name = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    consultation_name = models.CharField(max_length=128)
    consultation_cost_id=models.IntegerField()
    fee_amount = models.DecimalField(max_digits=9, decimal_places=2)
    fee_status = models.CharField(max_length=16)

    class Meta:
        managed = False
        db_table = "v_consultation_cost_1_a"


class view_v_diagnosis_cost_1_a(models.Model):
    diagnosis_id = models.BigAutoField(primary_key=True)
    #admission_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category_name = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    diagnosis_category_name = models.CharField(max_length=64)
    diagnosis_category_id=models.IntegerField()
    
    diagnosis_name = models.CharField(max_length=64)
    fee_amount = models.DecimalField(max_digits=9, decimal_places=2)
    fee_status = models.CharField(max_length=16)

    class Meta:
        managed = False
        db_table = "v_diagnosis_cost_1_a"

class view_v_temp_sales_token_details_hc_consul_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    consultation_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    consultation_name = models.CharField(max_length=128)
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity = models.DecimalField(max_digits=7, decimal_places=2)
    token_status = models.CharField(max_length=32)
    doctors_id=models.IntegerField()
    doctors_name = models.CharField(max_length=32)
    consul_date = models.CharField(max_length=32)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_hc_consul_1_b"



class view_v_temp_sales_token_cons_and_history_1_b(models.Model):
    symptom_history_id= models.BigAutoField(primary_key=True)
    token_id = models.IntegerField()
    consultation_id=models.IntegerField()
    patient_id=models.IntegerField()
    patient_name=models.CharField(max_length=64)  ###  telephone
    telephone= models.CharField(max_length=32)
    card_no= models.CharField(max_length=32)
    patient_code= models.CharField(max_length=32)
    sales_token_no = models.CharField(max_length=32)   ###   tokendateandtime
    tokendateandtime=models.DateTimeField()

    doctors_id=models.IntegerField()
    doctors_name = models.CharField(max_length=32)
    cons_date = models.DateTimeField()   ###   medical_history_name

    medical_history_name = models.CharField(max_length=64)  ###   ` medical_history_category_id
    medical_history_category_id=models.IntegerField()
    medical_history_category_name=models.CharField(max_length=64)
    
    # consultation_name = models.CharField(max_length=128)
    # unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    # quantity = models.DecimalField(max_digits=7, decimal_places=2)
    # token_status = models.CharField(max_length=32)
   

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_cons_and_history_1_b"



class view_v_medicine_with_fee_1_b(models.Model):
    medicine_product_id = models.BigAutoField(primary_key=True)
    medicine_category_id = models.IntegerField()
    service_category_id=models.IntegerField()
    service_category = models.CharField(max_length=64)
    medicine_category_name = models.CharField(max_length=64)
    medicine_id = models.IntegerField()
    medicine_name = models.CharField(max_length=128)
    medicine_product_name = models.CharField(max_length=128)
    cost_id=models.IntegerField()
    single_unit=models.IntegerField()
    cost_amount = models.DecimalField(max_digits=9, decimal_places=2)
    item_id=models.IntegerField()
    uoq = models.CharField(max_length=32)

    class Meta:
        managed = False
        db_table = "v_medicine_with_fee_1_b"
###   v_temp_sales_token_details_hc_adm_1_b


class view_v_temp_sales_token_details_hc_med_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    medicine_id=models.IntegerField()
    medicine_product_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    medicine_product_name = models.CharField(max_length=128)
    medicine_name = models.CharField(max_length=128)
    #admission_cost_id=models.IntegerField()
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity = models.DecimalField(max_digits=7, decimal_places=2)
    token_status = models.CharField(max_length=32)
    uoq = models.CharField(max_length=32)
    pay_status = models.CharField(max_length=32)
    frequency = models.CharField(max_length=64)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name medicine_product   medicine

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_hc_med_1_b"


class view_v_medical_services_1_a(models.Model):
    medical_service_fee_id = models.BigAutoField(primary_key=True)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    medical_service_id=models.IntegerField()
    service_category_id=models.IntegerField()
    #medicine_product_id=models.IntegerField()
    service_category_name = models.CharField(max_length=64)
    medical_service_name = models.CharField(max_length=64)

    fee_amount = models.DecimalField(max_digits=9, decimal_places=2)

    class Meta:
        managed = False
        db_table = "v_medical_services_1_a"


class view_v_patient_details_1_a(models.Model):
    patient_id = models.BigAutoField(primary_key=True)
    first_name = models.CharField(max_length=32)
    middle_name = models.CharField(max_length=32)
    last_name = models.CharField(max_length=32)
    patient_name = models.CharField(max_length=64)
    telephone = models.CharField(max_length=32)
    gender = models.CharField(max_length=32)
    address = models.CharField(max_length=32)
    dob = models.CharField(max_length=32)
    card_no = models.CharField(max_length=32)
    insurance_name = models.CharField(max_length=64)
    patient_code = models.CharField(max_length=64)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    patient_insurance_id=models.IntegerField()
    insurance_id=models.IntegerField()
    #medicine_product_id=models.IntegerField()

    class Meta:
        managed = False
        db_table = "v_patient_details_1_a"


class view_v_patient_details_1_a_old(models.Model):
    patient_id = models.BigAutoField(primary_key=True)
    first_name = models.CharField(max_length=32)
    middle_name = models.CharField(max_length=32)
    last_name = models.CharField(max_length=32)
    patient_name = models.CharField(max_length=64)
    telephone = models.CharField(max_length=32)
    gender = models.CharField(max_length=32)
    address = models.CharField(max_length=32)
    dob = models.CharField(max_length=32)
    card_no = models.CharField(max_length=32)
    insurance_name = models.CharField(max_length=64)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    patient_insurance_id=models.IntegerField()
    insurance_id=models.IntegerField()
    #medicine_product_id=models.IntegerField()

    class Meta:
        managed = False
        db_table = "v_patient_details_1_a"


class view_v_medical_service_and_fee_1_a(models.Model):
    medical_service_id = models.BigAutoField(primary_key=True)
    service_category_id=models.IntegerField()
    medical_service_fee_id=models.IntegerField()
    medical_service_name = models.CharField(max_length=64)
    service_category_name = models.CharField(max_length=64)
    fee_amount=models.DecimalField(max_digits=9, decimal_places=2)

    #medicine_product_id=models.IntegerField()

    class Meta:
        managed = False
        db_table = "v_medical_service_and_fee_1_a"



class view_v_temp_sales_token_details_hc_medical_service_1_b(models.Model):
    temp_sales_token_id = models.BigAutoField(primary_key=True)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    medical_service_id=models.IntegerField()
    sales_token_no = models.CharField(max_length=64)
    #medicine_category_name = models.CharField(max_length=64)
    medical_service_name = models.CharField(max_length=128)
    #admission_cost_id=models.IntegerField()
    unit_price = models.DecimalField(max_digits=9, decimal_places=2)
    quantity = models.DecimalField(max_digits=7, decimal_places=2)
    token_status = models.CharField(max_length=32)
    ###   a.id as service_category_id, a.name as service_category,
    ###   b.id as lab_test_category_id, b.name as lab_category_name
    medical_service_taken_date_time = models.DateTimeField(max_length=32,default="") ###wages_date = models.DateTimeField("SHORT_DATETIME_FORMAT")
    medical_service_taken_status = models.CharField(max_length=64)
    medical_service_result = models.CharField(max_length=64)
    medical_service_result_date_time = models.DateTimeField(max_length=32,default="")
    medical_service_taken_username = models.CharField(max_length=64)
    medical_service_result_username = models.CharField(max_length=64)
    pay_status = models.CharField(max_length=32)

    class Meta:
        managed = False
        db_table = "v_temp_sales_token_details_hc_medical_service_1_b"


class view_v_product_package_formulars_1_a(models.Model):
    product_package_formular_parent_id = models.BigAutoField(primary_key=True)
    #product_package_formular_parent_id=models.IntegerField()
    product_package_formular_details_id=models.IntegerField()
    item_name=models.CharField(max_length=64)
    ###temp_sales_token_id=models.IntegerField()
    #admission_category_id = models.IntegerField()
    item_id=models.IntegerField()
    package_name=models.CharField(max_length=64)
    number_of_items_per_package=models.IntegerField()
    #medicine_product_id=models.IntegerField()
    #service_category_name = models.CharField(max_length=64) item_package_material_id
    #medical_service_name = models.CharField(max_length=64) package_material_name
    #package_material_name=models.CharField(max_length=64) item_package_material_id
    #item_package_material_id=models.IntegerField()
    
    qty_of_single_item_per_uoq = models.DecimalField(max_digits=9, decimal_places=2)
    #package_material=models.CharField(max_length=64)

    class Meta:
        managed = False
        db_table = "v_product_package_formulars_1_a"

